/* Linked List */

#include <iostream>
#include <memory>

using namespace std;

class Nodey {
	public:

      int info;
      shared_ptr<Nodey> next;

      Nodey(int);
};


class Listy {
	shared_ptr<Nodey> head;
    
    public:

    void push(int);
    void addAtEnd(int);
    void printList();
};

Nodey::Nodey(int num){
   info = num;
}

void Listy::push(int num){
	shared_ptr<Nodey> tmp = make_shared<Nodey>(num);
	tmp->next = head;
	head = tmp;
}

void Listy::addAtEnd(int num){
	shared_ptr<Nodey> tmp = make_shared<Nodey>(num);
	if (head == NULL){
		head = tmp;
	}
	shared_ptr<Nodey> current = head;
	while(current->next != NULL){ 
		current = current->next;
	}
	current->next = tmp;

}

void Listy::printList(){
	shared_ptr<Nodey> nextPtr = head;
	while (nextPtr != NULL){
		cout << nextPtr->info << endl;
		nextPtr = nextPtr->next;
	}
}


int main(){
	shared_ptr<Listy> myList = make_shared<Listy>();
    myList->push(10);
    myList->push(20);
    myList->push(30);
    myList->addAtEnd(5);
    myList->addAtEnd(1);
    myList->printList();

    /* PARTNER TASK */

    /* // TODO:  add delete method
    myList->deleteNode(10);
    myList->deleteNode(1);
    myList->deleteNode(30);
    // should print 20    5
    myList->printList();
    */

    /* //TODO: add addAfter method
    // return true if the number was found and an add took place
    // false otherwise
    cout << myList->addAfter(20, 18);  // add after 20 the number 18
    cout << myList->addAfter(15, 11);  // return false
    cout << myList->addAfter(18, 12);
    cout << myList->addAfter(1, 99);
    myList->printList();
   
    */
    
}